*! version 1.0.9  11nov2009  Ben Jann

program cwreg, eclass byable(recall) prop(svyb svyj svyr swml)
    version 9.0
    local caller : di _caller()
    if replay() {
        if `"`e(cmd2)'"'!="cwreg" {
            di as err "last estimates not found"
            exit 301
        }
        version `caller': Display `0'
        exit
    }
    *syntax varlist(numeric) [if] [in] [aw fw iw pw] [, PYes(str) PNo(str) *]
    syntax varlist(numeric) [if] [in] [aw fw iw pw] [, Pyes(str) ///
        Level(passthru) Beta EForm(passthru) noHEader plus DEPname(str) * ]
    if `"`pyes'"'=="" local pyes 1

    marksample touse
    capt assert (`pyes'>=0) & (`pyes'<=1) if `touse'
    if _rc {
        di as err "pyes() must be in [0,1]"
        exit 198
    }

    tempvar cwvar
    gettoken depvar indepvars : varlist
    qui gen double `cwvar' = (`depvar'!=0) if `touse'
    ta `cwvar' if `touse', nofreq
    if r(r)<2 {
        di as txt "outcome does not vary; remember:"
        di as txt _col(35) "0 = negative outcome,"
        di as txt _col(9) /*
        */ "all other nonmissing values = positive outcome"
                exit 2000
        }
    if `"`depname'"'=="" local depname `depvar'
    qui replace `cwvar' = (`cwvar' + `pyes' - 1) / (2*`pyes'-1) if `touse'
    qui version `caller': regress `cwvar' `indepvars' if `touse' [`weight'`exp'], depname(`depname') `options'
    eret local title "Crosswise model regression"
    eret local cmd2 "cwreg"
    eret local cmdline `"`0'"'
    eret local pyes "`pyes'"
    Display, `level' `beta' `eform' `header' `plus'
end

prog Display
    version 9.0
    local caller : di _caller()
    syntax [, noHEader * ]
    if "`header'"=="" {
        version `caller': _coef_table_header
        di ""
    }
    version `caller': regress, noheader `options'
    di ""
    di as txt `"Pr(surrogate "yes") = "' as res `"`e(pyes)'"'
end
